diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/misc.c tin-2.6.5/src/misc.c
--- tin-2.6.4/src/misc.c	2024-12-22 18:22:28.000000000 +0100
+++ tin-2.6.5/src/misc.c	2025-12-20 18:11:31.243627963 +0100
@@ -3,10 +3,10 @@
  *  Module    : misc.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-22
+ *  Updated   : 2025-12-07
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -111,6 +111,10 @@
 
 #ifdef HAVE_LIBURIPARSER
 #	include <uriparser/Uri.h>
+#else
+#	ifdef HAVE_LIBCURL
+#		include <curl/curl.h>
+#	endif /* HAVE_LIBCURL */
 #endif /* HAVE_LIBURIPARSER */
 
 /*
@@ -125,13 +129,13 @@
 /*
  * Local prototypes
  */
-static char *strfpath_cp(char *str, char *tbuf, const char *endp);
+static char *strfpath_cp(char *str, const char *tbuf, const char *endp);
 static int _strfpath(const char *format, char *str, size_t maxsize, struct t_group *group, t_bool expand_all);
 static int gnksa_check_domain(char *domain);
 static int gnksa_check_domain_literal(const char *domain);
 static int gnksa_check_localpart(const char *localpart);
-static int gnksa_dequote_plainphrase(char *realname, char *decoded, int addrtype);
-static int strfeditor(const char *editor, int linenum, const char *filename, char *s, size_t maxsize, char *format);
+static int gnksa_dequote_plainphrase(const char *realname, char *decoded, int addrtype);
+static int strfeditor(const char *editor, int linenum, const char *filename, char *s, size_t maxsize, const char *format);
 static void make_connection_page(FILE *fp);
 static void write_input_history_file(void);
 #ifdef CHARSET_CONVERSION
@@ -271,8 +275,10 @@ copy_fp(
 			return errno;
 		}
 		TRACE(("copy_fp wrote %d:{%.*s}", sent, (int) sent, buf));
+		if (feof(fp_ip) || ferror(fp_ip))
+			break;
 	}
-	return 0;
+	return (ferror(fp_ip) ? -1 : 0);
 }
 
 
@@ -342,7 +348,9 @@ backup_file(
  * prefix (= quote_chars), initials of the articles author
  * with_sig is set if the signature should be quoted
  *
- * TODO: rewrite from scratch, the code is awful!
+ * TODO: - rewrite from scratch, the code is awful!
+ *       - handle format-flowed (rewrapping, space stuffing,
+ *         force quote compression?, ...)
  */
 void
 copy_body(
@@ -551,7 +559,7 @@ invoke_ispell(
 		return FALSE;
 	}
 
-	while (fgets(buf, (int) sizeof(buf), fp_all) != NULL) {
+	while (fgets(buf, sizeof(buf), fp_all) != NULL) {
 		fputs(buf, fp_head);
 		if (buf[0] == '\n' || buf[0] == '\r') {
 			fclose(fp_head);
@@ -564,7 +572,7 @@ invoke_ispell(
 		fclose(fp_head);
 
 	while (!feof(fp_all) && !ferror(fp_all)) {
-		if (fgets(buf, (int) sizeof(buf), fp_all) != NULL)
+		if (fgets(buf, sizeof(buf), fp_all) != NULL)
 			fputs(buf, fp_body);
 		else
 			break;
@@ -722,9 +730,10 @@ tin_done(
 
 			if (wrote_newsrc_lines < read_newsrc_lines) {
 				/* FIXME: prompt for retry? (i.e. remove break) */
+				/* FIXME: translatable/plural-forms in txt_warn_newsrc (break into two strings (one per sentence)) */
 				wait_message(0, _(txt_warn_newsrc), newsrc,
 					(read_newsrc_lines - wrote_newsrc_lines),
-					PLURAL(read_newsrc_lines - wrote_newsrc_lines, txt_group),
+					P_(txt_group_sp[0], txt_group_sp[1], read_newsrc_lines - wrote_newsrc_lines),
 					OLDNEWSRC_FILE);
 				if (!batch_mode)
 					prompt_continue();
@@ -1002,16 +1011,12 @@ base_name(
 	const char *fullpath,		/* /foo/bar/baz */
 	char *file)				/* baz */
 {
-	size_t i;
+	char *p = strrchr(fullpath, '/');
 
-	strcpy(file, fullpath);
-
-	for (i = strlen(fullpath) - 1; i; i--) {
-		if (fullpath[i] == '/') {
-			strcpy(file, fullpath + i + 1);
-			break;
-		}
-	}
+	if (p && *(p + 1))
+		strcpy(file, p + 1);
+	else
+		strcpy(file, fullpath);
 }
 
 
@@ -1053,7 +1058,7 @@ mail_check(
 	mb = my_strdup(mailbox_name); /* take a copy due to strtok() */
 
 	/*
-	 * remove custom messages for now; rughly based on
+	 * remove custom messages for now; roughly based on
 	 * <https://pubs.opengroup.org/onlinepubs/9699919799/utilities/sh.html>
 	 *
 	 * TODO: if '\'-quoting is limited to '%' outside the message, there
@@ -1207,8 +1212,7 @@ get_author(
 	size_t len)
 {
 	char *p, *ptr = str;
-	int author;
-	size_t curr_len, rem_len = len - 1;
+	int author, curr_len, rem_len = len;
 	struct t_mailbox *mb = &art->mailbox;
 
 	*ptr = '\0';
@@ -1220,11 +1224,11 @@ get_author(
 
 		switch (author) {
 			case SHOW_FROM_ADDR:
-				strncpy(ptr, p, rem_len);
+				snprintf(ptr, rem_len, "%s", p);
 				break;
 
 			case SHOW_FROM_NAME:
-				strncpy(ptr, (mb->name ? mb->name : p), rem_len);
+				snprintf(ptr, rem_len, "%s", mb->name ? mb->name : p);
 				break;
 
 			case SHOW_FROM_BOTH:
@@ -1233,9 +1237,8 @@ get_author(
 						snprintf(ptr, rem_len, "\"%s\" <%s>", mb->name, p);
 					else
 						snprintf(ptr, rem_len, "%s <%s>", mb->name, p);
-				}
-				else
-					strncpy(ptr, p, rem_len);
+				} else
+					snprintf(ptr, rem_len, "%s", p);
 				break;
 
 			case SHOW_FROM_NONE:
@@ -1246,13 +1249,14 @@ get_author(
 
 		free(p);
 
-		/* we stop if there is no room for at least one character after ”, ” */
+		/* we stop if there is no room for at least one character after ", " */
 		if (rem_len < 5)
 			mb = NULL;
 		else if ((mb = mb->next)) {
 			strcat(ptr, ", ");
 			curr_len = strlen(ptr);
-			rem_len -= curr_len;
+			if ((rem_len -= curr_len) <= 0)
+				break;
 			ptr += curr_len;
 		}
 	} while (mb);
@@ -1324,8 +1328,6 @@ show_color_status(
 /*
  * Check for lock file to stop multiple copies of tin -u running and if it
  * does not exist create it so this is the only copy running
- *
- * FIXME: get rid of hard coded pid-length as pid_t might be long
  */
 void
 create_index_lock_file(
@@ -1333,19 +1335,23 @@ create_index_lock_file(
 {
 	FILE *fp;
 	char buf[64];
+	char *cp;
 	int err;
 	time_t epoch;
 
 	if ((fp = tin_fopen(the_lock_file, "r")) != NULL) {
-		err = (fgets(buf, (int) sizeof(buf), fp) == NULL);
+		err = (fgets(buf, sizeof(buf), fp) == NULL);
 		fclose(fp);
-		error_message(2, "%s: Already started pid=[%d] on %s", tin_progname, err ? 0 : s2i(buf, 0, INT_MAX), err ? "-" : buf + 9);
-#ifdef DEBUG
-		if (debug & DEBUG_MISC) {
-			if (!err)
-				error_message(0, "Lockfile: %s", the_lock_file);
-		}
-#endif /* DEBUG */
+		if (!err) {
+			for (cp = buf; *cp; cp++) {
+				if (!isdigit((unsigned char) *cp) && !isspace((unsigned char) *cp))
+					break;
+			}
+			str_trim(cp);
+			/* TODO:check errno after s2i()? (EINVAL == malformed lock) */
+			error_message(2, "%s: Already started pid=[%d] on %s [%s]", tin_progname, s2i(buf, 0, INT_MAX), BlankIfNull(cp), the_lock_file);
+		} else
+			error_message(2, "%s: Already started [%s]", tin_progname, the_lock_file);
 
 		free(tin_progname);
 		giveup();
@@ -1359,7 +1365,7 @@ create_index_lock_file(
 #	endif /* HAVE_CHMOD */
 #endif /* HAVE_FCHMOD */
 		(void) time(&epoch);
-		fprintf(fp, "%6d  %s\n", (int) process_id, BlankIfNull(str_trim(ctime(&epoch))));
+		fprintf(fp, "%ld  %s\n", (long) process_id, BlankIfNull(str_trim(ctime(&epoch))));
 		if ((err = ferror(fp)) || fclose(fp)) {
 			error_message(2, _(txt_filesystem_full), the_lock_file);
 			if (err) {
@@ -1389,7 +1395,7 @@ strfquote(
 	int respnum,
 	char *s,
 	size_t maxsize,
-	char *format)
+	const char *format)
 {
 	const char *endp;
 	char *start = s;
@@ -1549,7 +1555,7 @@ strfeditor(
 	const char *filename,
 	char *s,
 	size_t maxsize,
-	char *format)
+	const char *format)
 {
 	const char *endp;
 	const char *start = s;
@@ -1626,7 +1632,7 @@ out:
 static char *
 strfpath_cp(
 	char *str,
-	char *tbuf,
+	const char *tbuf,
 	const char *endp)
 {
 	size_t i;
@@ -1917,7 +1923,7 @@ strfpath(
 char *
 escape_shell_meta(
 	const char *source,
-	int quote_area)
+	enum quote_enum quote_area)
 {
 	static char buf[PATH_LEN];
 	char *dest = buf;
@@ -1963,9 +1969,6 @@ escape_shell_meta(
 				--space;
 			}
 			break;
-
-		default:
-			break;
 	}
 
 	*dest = '\0';
@@ -1995,7 +1998,7 @@ strfmailer(
 	const char *endp;
 	const char *start = dest;
 	char tbuf[PATH_LEN];
-	int quote_area = no_quote;
+	enum quote_enum quote_area = no_quote;
 
 	/*
 	 * safe guards: no destination to write to, no format, no space to
@@ -2228,7 +2231,7 @@ get_initials(
 		}
 		ptr[j] = '\0';
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-		/* we stop if there is no room for at least one character after ”, ” */
+		/* we stop if there is no room for at least one character after ", " */
 		if (rem_len < 5)
 			mb = NULL;
 		else if ((mb = mb->next)) {
@@ -2318,8 +2321,28 @@ cleanup_tmp_files(
 	 * only required if update_index == TRUE, but update_index is
 	 * unknown here
 	 */
-	if (batch_mode)
+	if (batch_mode) {
 		unlink(lock_file);
+		return;
+	}
+
+	/*
+	 * remove any cached help pages (!batch_mode only)
+	 * ${TIN_HOMEDIR:-"$HOME"}/.tin/$NNTPSERVER/.help-*
+	 */
+	if (*serverdir) {
+		char tmp[NAME_LEN];
+		char cfile[PATH_LEN];
+		short i;
+
+		for (i = MIN_LEVEL; i < MAX_LEVEL; i <<= 1) {
+			snprintf(tmp, sizeof(tmp), HELP_PAGE_CACHE_FILE, i);
+			joinpath(cfile, sizeof(cfile), serverdir, tmp);
+			(void) unlink(cfile);
+		}
+		joinpath(cfile, sizeof(cfile), serverdir, CONINFO_CACHE_FILE);
+		(void) unlink(cfile);
+	}
 }
 
 
@@ -2365,12 +2388,12 @@ random_organization(
 	if (*in_org != '/')
 		return in_org;
 
-	*selorg = '\0';
+	selorg[0] = '\0';
 
 	if ((orgfp = tin_fopen(in_org, "r")) == NULL)
 		return selorg;
 
-	while (fgets(selorg, (int) sizeof(selorg), orgfp))
+	while (fgets(selorg, sizeof(selorg), orgfp))
 		++nool;
 
 	if (nool) {
@@ -2380,7 +2403,7 @@ random_organization(
 		sol = rndm() % nool + 1;
 		nool = 0;
 
-		while ((nool != sol) && (fgets(selorg, (int) sizeof(selorg), orgfp)))
+		while ((nool != sol) && (fgets(selorg, sizeof(selorg), orgfp)))
 			++nool;
 	}
 
@@ -2409,7 +2432,7 @@ read_input_history_file(
 	memset((void *) hist_last, 0, sizeof(hist_last));
 	memset((void *) hist_pos, 0, sizeof(hist_pos));
 
-	while (fgets(buf, (int) sizeof(buf), fp)) {
+	while (fgets(buf, sizeof(buf), fp)) {
 		if ((chr = strpbrk(buf, "\n\r")) != NULL)
 			*chr = '\0';
 
@@ -2517,7 +2540,7 @@ write_input_history_file(
  */
 char *
 quote_wild(
-	char *str)
+	const char *str)
 {
 	char *target;
 	static char buff[2 * LEN];	/* on the safe side */
@@ -2553,13 +2576,13 @@ quote_wild(
  */
 char *
 quote_wild_whitespace(
-	char *str)
+	const char *str)
 {
 	char *target;
 	static char buff[2 * LEN];	/* on the safe side */
 
-	for (target = buff; *str != '\0'; str++) {
-		if (tinrc.wildcard) { /* regex */
+	if (tinrc.wildcard) { /* regex */
+		for (target = buff; *str != '\0'; str++) {
 			/*
 			 * replace whitespace with '\s' (pcre)
 			 */
@@ -2568,10 +2591,12 @@ quote_wild_whitespace(
 				*target++ = 's';
 			} else
 				*target++ = *str;
-		} else	/* wildmat */
-			*target++ = *str;
+		}
+		*target = '\0';
+	} else {	/* wildmat */
+		STRCPY(buff, str);
 	}
-	*target = '\0';
+
 	return buff;
 }
 
@@ -2607,6 +2632,10 @@ buffer_to_local( /* TODO: rename to some
 
 	/* FIXME: this should default in RFC2046.c to US-ASCII */
 	if ((from_charset && *from_charset)) {	/* Content-Type: had a charset parameter */
+		/* iconv() might crash on broken multibyte sequences so check them */
+		if (charset_compare(from_charset, "UTF-8"))
+			(void) utf8_valid(*line);
+
 		if (strcasecmp(from_charset, to_charset)) { /* different charsets */
 #	ifdef CHARSET_CONVERSION_ICONV
 			char *clocal_charset;
@@ -2618,10 +2647,6 @@ buffer_to_local( /* TODO: rename to some
 				clocal_charset = append_to_string(clocal_charset, "//TRANSLIT");
 #		endif /* HAVE_ICONV_OPEN_TRANSLIT */
 
-			/* iconv() might crash on broken multibyte sequences so check them */
-			if (!strcasecmp(from_charset, "UTF-8") || !strcasecmp(from_charset, "utf8"))
-				(void) utf8_valid(*line);
-
 			/*
 			 * TODO: hardcode unknown_ucs4 (0x00 0x00 0x00 0x3f)
 			 *       instead of converting it?
@@ -2708,7 +2733,7 @@ buffer_to_local( /* TODO: rename to some
 					if (result == (size_t) (-1)) {
 						switch (errno) {
 							case EILSEQ:
-								**&outbuf = '?';
+								*outbuf = '?';
 								++outbuf;
 								--outbytesleft;
 								inbuf += 4;
@@ -2739,10 +2764,10 @@ buffer_to_local( /* TODO: rename to some
 					}
 				} while (inbytesleft > 0);
 
-				**&outbuf = '\0';
-				if (*max_line_len < strlen(obuf) + 1) {
-					*max_line_len = strlen(obuf) + 1;
-					*line = my_realloc(*line, *max_line_len);
+				*outbuf = '\0';
+				if (*max_line_len < strlen(obuf)) {
+					*max_line_len = strlen(obuf);
+					*line = my_realloc(*line, *max_line_len + 1);
 				}
 				strcpy(*line, obuf);
 				iconv_close(cd2);
@@ -2843,13 +2868,8 @@ process_charsets(
 
 #ifdef CHARSET_CONVERSION
 	if (strcasecmp(from_charset, "US-ASCII")) {	/* from_charset is NOT US-ASCII */
-		if (iso2asc_supported >= 0)
-			p = my_strdup("ISO-8859-1");
-		else
-			p = my_strdup(to_charset);
-		if (!buffer_to_local(line, max_line_len, from_charset, p))
+		if (!buffer_to_local(line, max_line_len, from_charset, iso2asc_supported >= 0 ? "ISO-8859-1" : to_charset))
 			buffer_to_ascii(*line);
-		free(p);
 	} else /* set non-ASCII characters to '?' */
 		buffer_to_ascii(*line);
 #else
@@ -2883,6 +2903,7 @@ process_charsets(
 		p = my_strdup(*line);
 		convert_iso2asc(p, line, max_line_len, iso2asc_supported);
 		free(p);
+		/* we now have (decorated) US-ASCII */
 	}
 }
 
@@ -3147,11 +3168,11 @@ gnksa_strerror(
  */
 static int
 gnksa_dequote_plainphrase(
-	char *realname,
+	const char *realname,
 	char *decoded,
 	int addrtype)
 {
-	char *rpos;	/* read position */
+	const char *rpos;	/* read position */
 	char *wpos;	/* write position */
 	int initialstate;	/* initial state */
 	int state;	/* current state */
@@ -3427,7 +3448,7 @@ gnksa_check_domain_literal(
 			}
 
 			free(p);
-            return n;
+			return n;
 		}
 #endif /* HAVE_INET_PTON && AF_INET6 */
 
@@ -3916,7 +3937,6 @@ strip_line(
 }
 
 
-#if defined(CHARSET_CONVERSION) || (defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE))
 /*
  * 'check' a given UTF-8 string and '?'-out illegal sequences
  * TODO: is this check complete?
@@ -4058,7 +4078,6 @@ utf8_valid(
 	}
 	return line;
 }
-#endif /* CHARSET_CONVERSION || (MULTIBYTE_ABLE && !NO_LOCALE) */
 
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
@@ -4108,12 +4127,12 @@ remove_soft_hyphens(
  */
 char *
 idna_decode(
-	char *in)
+	const char *in)
 {
 	char *out = my_strdup(in);
 
 	/* decoding needed? */
-	if (!strstr(in, "xn--"))
+	if (!strcasestr(in, ACE_PREFIX))
 		return out;
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
@@ -4131,7 +4150,7 @@ idna_decode(
 
 		len = (size_t) (t - out);
 
-		if (len && (rs = idn2_to_unicode_lzlz(t, &s, IDN2_USE_STD3_ASCII_RULES)) == IDN2_OK) {
+		if (len && (rs = idn2_to_unicode_lzlz(t, &s, IDN2_USE_STD3_ASCII_RULES)) == IDN2_OK) { /* NOLINT(clang-analyzer-deadcode.DeadStores) */
 			char *q = my_strndup(out, len); /* local-part@ */
 
 			free(out);
@@ -4368,162 +4387,13 @@ tin_version_info(
 	UVersionInfo version;
 	char buf[U_MAX_VERSION_STRING_LENGTH + 1];
 #	endif /* HAVE_LIBICUUC */
-#else
-	(void) verb;
-#endif /* REPRODUCIBLE_BUILD */
-
-	fprintf(fp, _(txt_tin_version), PRODUCT, VERSION, RELEASEDATE, RELEASENAME);
-#if defined(__DATE__) && defined(__TIME__) && !defined(REPRODUCIBLE_BUILD)
-	fprintf(fp, " %s %s", __DATE__, __TIME__);
-#endif /* __DATE__ && __TIME__ && !REPRODUCIBLE_BUILD */
-	fprintf(fp, "\n");
-	++wlines;
-
-#ifdef SYSTEM_NAME
-	fprintf(fp, "Platform:\n");
-	fprintf(fp, "\tOS-Name  = \"%s\"\n", SYSTEM_NAME);
-	wlines += 2;
-#endif /* SYSTEM_NAME */
-
-#ifdef TIN_CC
-	fprintf(fp, "Compiler:\n");
-	fprintf(fp, "\tCC       = \"%s\"\n", TIN_CC);
-	wlines += 2;
-#	if defined(TIN_CFLAGS) && !defined(REPRODUCIBLE_BUILD)
-	if (verb) {
-		fprintf(fp, "\tCFLAGS   = \"%s\"\n", TIN_CFLAGS);
-		++wlines;
-	}
-#	endif /* TIN_CFLAGS && !REPRODUCIBLE_BUILD */
-#	ifdef TIN_CPP
-		fprintf(fp, "\tCPP      = \"%s\"\n", TIN_CPP);
-		++wlines;
-#	endif /* TIN_CPP */
-#	if defined(TIN_CFLAGS) && !defined(REPRODUCIBLE_BUILD)
-	if (verb) {
-		fprintf(fp, "\tCPPFLAGS = \"%s\"\n", TIN_CPPFLAGS);
-		++wlines;
-	}
-#	endif /* TIN_CPPFLAGS && !REPRODUCIBLE_BUILD */
-#endif /* TIN_CC */
-
-#ifdef TIN_LD
-	fprintf(fp, "Linker and Libraries:\n");
-	fprintf(fp, "\tLD       = \"%s\"\n", TIN_LD);
-	wlines += 2;
-#	if defined(TIN_LDFLAGS) && !defined(REPRODUCIBLE_BUILD)
-	if (verb) {
-		fprintf(fp, "\tLDFLAGS  = \"%s\"\n", TIN_LDFLAGS);
-		++wlines;
-	}
-#	endif /* TIN_LDFLAGS && !REPRODUCIBLE_BUILD */
-#	ifdef TIN_LIBS
-		fprintf(fp, "\tLIBS     = \"%s\"\n", TIN_LIBS);
-		++wlines;
-#	endif /* TIN_LIBS */
-#endif /* TIN_LD */
-
-#ifndef REPRODUCIBLE_BUILD
-	if (verb) {
-#	ifdef NNTPS_ABLE
-#		ifdef HAVE_LIB_LIBTLS
-		fprintf(fp, "\tTLS      = \"LibreSSL %d\"\n", TLS_API);
-#		else
-#			ifdef HAVE_LIB_OPENSSL
-		fprintf(fp, "\tTLS      = \"%s\"\n", OpenSSL_version(OPENSSL_VERSION));
-#			else
-#				ifdef HAVE_LIB_GNUTLS
-		fprintf(fp, "\tTLS      = \"GnuTLS %s\"\n", gnutls_check_version(NULL));
-#				endif /* HAVE_LIB_GNUTLS */
-#			endif /* HAVE_LIB_OPENSSL */
-#		endif /* HAVE_LIB_LIBTLS */
-		++wlines;
-#	endif /* NNTPS_ABLE */
-
-#	ifdef HAVE_LIB_PCRE2
-		pcre2_version_length = pcre2_config_8(PCRE2_CONFIG_VERSION, NULL);
-		if (pcre2_version_length > 0) {
-			pcre2_version = my_malloc(pcre2_version_length);
-			(void) pcre2_config_8(PCRE2_CONFIG_VERSION, pcre2_version);
-		}
-		fprintf(fp, "\tPCRE2    = \"%s\"\n", pcre2_version ? pcre2_version : txt_unknown);
-		FreeIfNeeded(pcre2_version);
-#	else
-		fprintf(fp, "\tPCRE     = \"%s\"\n", pcre_version());
-#	endif /* HAVE_LIB_PCRE2 */
-		++wlines;
-
-#	ifdef USE_CURSES
-#		ifdef HAVE_CURSES_VERSION
-		fprintf(fp, "\tCURSES   = \"%s\"\n", curses_version());
-		++wlines;
-#		else
-#			if defined(NCURSES_VERSION_MAJOR) && NCURSES_VERSION_MAJOR < 5
-		fprintf(fp, "\tCURSES   = \"ncurses %s\"\n", NCURSES_VERSION);
-		++wlines;
-#			endif /* NCURSES_VERSION_MAJOR && NCURSES_VERSION_MAJOR < 5*/
-#			if defined(PDCURSES) && defined(PDC_VERDOT)
-		fprintf(fp, "\tCURSES   = \"PDCurses %s\"\n", PDC_VERDOT);
-		++wlines;
-#			endif /* PDCURSES && PDC_VERDOT */
-#		endif /* HAVE_CURSES_VERSION */
-#	endif /* USE_CURSES */
-
-#	ifdef USE_GSASL
-		fprintf(fp, "\tGNU SASL = \"%s\"\n", gsasl_check_version(NULL));
-		++wlines;
-#	endif /* USE_GSASL */
-
-#	ifdef HAVE_LIBICUUC
-		u_getVersion(version);
-		u_versionToString(version, buf);
-		fprintf(fp, "\tICU      = \"%s", buf);
-#		ifdef USE_ICU_UCSDET
-		u_getUnicodeVersion(version);
-		u_versionToString(version, buf);
-		fprintf(fp, " (Unicode %s)", buf);
-#		endif /* USE_ICU_UCSDET */
-		fprintf(fp, "\"\n");
-		++wlines;
-#	endif /* HAVE_LIBICUUC */
-
-#	if defined(HAVE_LIBUNISTRING) && defined(HAVE_UNISTRING_VERSION_H) && (_LIBUNISTRING_VERSION > 0x000009)
-		fprintf(fp, "\tUNISTRING= \"%d.%d.%d\"\n", (_LIBUNISTRING_VERSION & 0xff0000) >> 16, (_LIBUNISTRING_VERSION & 0x00ff00) >> 8, _LIBUNISTRING_VERSION & 0x0000ff);
-		++wlines;
-#	endif /* HAVE_LIBUNISTRING && HAVE_UNISTRING_VERSION_H && _LIBUNISTRING_VERSION > 0x000009 */
-
-#	if defined(HAVE_LIBIDNKIT) && defined (HAVE_IDN_VERSION_H)
-		fprintf(fp, "\tIDNKIT   = \"%s\"\n", idn_version_libidn());
-		++wlines;
-#	endif /* HAVE_LIBIDNKIT && HAVE_IDN_VERSION_H */
-
-#	if defined(HAVE_LIBIDN2) && defined(IDN2_VERSION)
-		fprintf(fp, "\tIDN2     = \"%s\"\n", IDN2_VERSION);
-		++wlines;
-#	endif /* HAVE_LIBIDN2 && IDN2_VERSION */
-
-#	if defined(HAVE_LIBIDN) && defined(HAVE_STRINGPREP_H)
-		fprintf(fp, "\tIDN      = \"%s\"\n", stringprep_check_version("0.3.0"));
-		++wlines;
-#	endif /* HAVE_LIBIDN && HAVE_STRINGPREP_H */
-
-#	ifdef USE_ZLIB
-		fprintf(fp, "\tZLIB     = \"%s\"\n", ZLIB_VERSION);
-		++wlines;
-#	endif /* USE_ZLIB */
-#	ifdef HAVE_LIBURIPARSER
-		fprintf(fp, "\tURIPARSER= \"%s\"\n", URI_VER_ANSI);
-		++wlines;
-#	endif /* HAVE_LIBURIPARSER */
-#	if defined(USE_CANLOCK) && defined(CL_API_MAJOR) && defined(CL_API_MINOR)
-		fprintf(fp, "\tCANLOCK  = \"%d.%d\"\n", CL_API_MAJOR, CL_API_MINOR);
-		++wlines;
-#	endif /* USE_CANLOCK && CL_API_MAJOR && CL_API_MINOR */
-	}
 #endif /* REPRODUCIBLE_BUILD */
-
-	fprintf(fp, "Characteristics:\n\t"
-/* TODO: complete list and do some useful grouping; show only in -vV case? */
+	/*
+	 * TODO: complete list and do some useful grouping;
+	 *       split into < 500byte strings;
+	 *       show (some info) only in -vV case?
+	 */
+	static const char *tin_character =
 #ifdef DEBUG
 			"+DEBUG"
 #else
@@ -4546,32 +4416,17 @@ tin_version_info(
 			" -NNTP_ABLE"
 #	endif /* NNTP_ABLE */
 #endif /* NNTP_ONLY */
-#ifdef USE_ZLIB
-			" +USE_ZLIB"
-#else
-			" -USE_ZLIB"
-#endif /* USE_ZLIB */
 #ifdef NO_POSTING
 			" +NO_POSTING"
 #else
 			" -NO_POSTING"
 #endif /* NO_POSTING */
-#ifdef BROKEN_LISTGROUP
-			" +BROKEN_LISTGROUP"
-#else
-			" -BROKEN_LISTGROUP"
-#endif /* BROKEN_LISTGROUP */
 			"\n\t"
-#ifdef XHDR_XREF
-			"+XHDR_XREF"
-#else
-			"-XHDR_XREF"
-#endif /* XHDR_XREF */
-#ifdef HAVE_FASCIST_NEWSADMIN
-			" +HAVE_FASCIST_NEWSADMIN"
+#ifdef USE_ZLIB
+			"+USE_ZLIB"
 #else
-			" -HAVE_FASCIST_NEWSADMIN"
-#endif /* HAVE_FASCIST_NEWSADMIN */
+			"-USE_ZLIB"
+#endif /* USE_ZLIB */
 #ifdef ENABLE_IPV6
 			" +ENABLE_IPV6"
 #else
@@ -4589,6 +4444,11 @@ tin_version_info(
 		"  +SOCKS"
 #	endif /* USE_SOCKS5 */
 #endif /* SOCKS */
+#ifdef HAVE_FASCIST_NEWSADMIN
+			" +HAVE_FASCIST_NEWSADMIN"
+#else
+			" -HAVE_FASCIST_NEWSADMIN"
+#endif /* HAVE_FASCIST_NEWSADMIN */
 			"\n\t"
 #ifdef NO_SHELL_ESCAPE
 			"+NO_SHELL_ESCAPE"
@@ -4742,8 +4602,182 @@ tin_version_info(
 #else
 			" -ALLOW_FWS_IN_NEWSGROUPLIST"
 #endif /* ALLOW_FWS_IN_NEWSGROUPLIST */
-			"\n");
+	;
+
+	fprintf(fp, _(txt_tin_version), PRODUCT, VERSION, RELEASEDATE, RELEASENAME);
+#if defined(__DATE__) && defined(__TIME__) && !defined(REPRODUCIBLE_BUILD)
+	fprintf(fp, " %s %s", __DATE__, __TIME__);
+#endif /* __DATE__ && __TIME__ && !REPRODUCIBLE_BUILD */
+	fprintf(fp, "\n");
+	++wlines;
+
+#ifdef SYSTEM_NAME
+	fprintf(fp, "Platform:\n");
+	fprintf(fp, "\tOS-Name  = \"%s\"\n", SYSTEM_NAME);
+	wlines += 2;
+#endif /* SYSTEM_NAME */
+
+#ifdef TIN_CC
+	fprintf(fp, "Compiler:\n");
+	fprintf(fp, "\tCC       = \"%s\"\n", TIN_CC);
+	wlines += 2;
+#	if defined(TIN_CFLAGS) && !defined(REPRODUCIBLE_BUILD)
+	if (verb) {
+		fprintf(fp, "\tCFLAGS   = \"%s\"\n", TIN_CFLAGS);
+		++wlines;
+	}
+#	endif /* TIN_CFLAGS && !REPRODUCIBLE_BUILD */
+#	ifdef TIN_CPP
+	fprintf(fp, "\tCPP      = \"%s\"\n", TIN_CPP);
+	++wlines;
+#	endif /* TIN_CPP */
+#	if defined(TIN_CFLAGS) && !defined(REPRODUCIBLE_BUILD)
+	if (verb) {
+		fprintf(fp, "\tCPPFLAGS = \"%s\"\n", TIN_CPPFLAGS);
+		++wlines;
+	}
+#	endif /* TIN_CPPFLAGS && !REPRODUCIBLE_BUILD */
+#endif /* TIN_CC */
+
+#ifdef TIN_LD
+	fprintf(fp, "Linker and Libraries:\n");
+	fprintf(fp, "\tLD       = \"%s\"\n", TIN_LD);
+	wlines += 2;
+#	if defined(TIN_LDFLAGS) && !defined(REPRODUCIBLE_BUILD)
+	if (verb) {
+		fprintf(fp, "\tLDFLAGS  = \"%s\"\n", TIN_LDFLAGS);
+		++wlines;
+	}
+#	endif /* TIN_LDFLAGS && !REPRODUCIBLE_BUILD */
+#	ifdef TIN_LIBS
+	fprintf(fp, "\tLIBS     = \"%s\"\n", TIN_LIBS);
+	++wlines;
+#	endif /* TIN_LIBS */
+#endif /* TIN_LD */
+
+#ifndef REPRODUCIBLE_BUILD
+	if (verb) {
+#	ifdef NNTPS_ABLE
+#		ifdef HAVE_LIB_LIBTLS
+		fprintf(fp, "\tTLS      = \"LibreSSL %d\"\n", TLS_API);
+#		else
+#			ifdef HAVE_LIB_OPENSSL
+		fprintf(fp, "\tTLS      = \"%s\"\n", OpenSSL_version(OPENSSL_VERSION));
+#			else
+#				ifdef HAVE_LIB_GNUTLS
+		fprintf(fp, "\tTLS      = \"GnuTLS %s\"\n", gnutls_check_version(NULL));
+#				endif /* HAVE_LIB_GNUTLS */
+#			endif /* HAVE_LIB_OPENSSL */
+#		endif /* HAVE_LIB_LIBTLS */
+		++wlines;
+#	endif /* NNTPS_ABLE */
+
+#	ifdef HAVE_LIB_PCRE2
+		pcre2_version_length = pcre2_config_8(PCRE2_CONFIG_VERSION, NULL);
+		if (pcre2_version_length > 0) {
+			pcre2_version = my_malloc(pcre2_version_length);
+			(void) pcre2_config_8(PCRE2_CONFIG_VERSION, pcre2_version);
+		}
+		fprintf(fp, "\tPCRE2    = \"%s\"\n", pcre2_version ? pcre2_version : txt_unknown);
+		FreeIfNeeded(pcre2_version);
+#	else
+		fprintf(fp, "\tPCRE     = \"%s\"\n", pcre_version());
+#	endif /* HAVE_LIB_PCRE2 */
+		++wlines;
+
+#	ifdef USE_CURSES
+#		ifdef HAVE_CURSES_VERSION
+		fprintf(fp, "\tCURSES   = \"%s\"\n", curses_version());
+		++wlines;
+#		else
+#			if defined(NCURSES_VERSION_MAJOR) && NCURSES_VERSION_MAJOR < 5
+		fprintf(fp, "\tCURSES   = \"ncurses %s\"\n", NCURSES_VERSION);
+		++wlines;
+#			endif /* NCURSES_VERSION_MAJOR && NCURSES_VERSION_MAJOR < 5*/
+#			if defined(PDCURSES) && defined(PDC_VERDOT)
+		fprintf(fp, "\tCURSES   = \"PDCurses %s\"\n", PDC_VERDOT);
+		++wlines;
+#			endif /* PDCURSES && PDC_VERDOT */
+#		endif /* HAVE_CURSES_VERSION */
+#	endif /* USE_CURSES */
+
+#	ifdef USE_GSASL
+		fprintf(fp, "\tGNU SASL = \"%s\"\n", gsasl_check_version(NULL));
+		++wlines;
+#	endif /* USE_GSASL */
+
+#	ifdef HAVE_LIBICUUC
+		u_getVersion(version);
+		u_versionToString(version, buf);
+		fprintf(fp, "\tICU      = \"%s", buf);
+#		ifdef USE_ICU_UCSDET
+		u_getUnicodeVersion(version);
+		u_versionToString(version, buf);
+		fprintf(fp, " (Unicode %s)", buf);
+#		endif /* USE_ICU_UCSDET */
+		fprintf(fp, "\"\n");
+		++wlines;
+#	endif /* HAVE_LIBICUUC */
+
+#	if defined(HAVE_LIBUNISTRING) && defined(HAVE_UNISTRING_VERSION_H) && (_LIBUNISTRING_VERSION > 0x000009)
+		fprintf(fp, "\tUNISTRING= \"%d.%d.%d\"\n", (_LIBUNISTRING_VERSION & 0xff0000) >> 16, (_LIBUNISTRING_VERSION & 0x00ff00) >> 8, _LIBUNISTRING_VERSION & 0x0000ff);
+		++wlines;
+#	endif /* HAVE_LIBUNISTRING && HAVE_UNISTRING_VERSION_H && _LIBUNISTRING_VERSION > 0x000009 */
+
+#	if defined(HAVE_LIBIDNKIT) && defined (HAVE_IDN_VERSION_H)
+		fprintf(fp, "\tIDNKIT   = \"%s\"\n", idn_version_libidn());
+		++wlines;
+#	endif /* HAVE_LIBIDNKIT && HAVE_IDN_VERSION_H */
+
+#	if defined(HAVE_LIBIDN2) && defined(IDN2_VERSION)
+		fprintf(fp, "\tIDN2     = \"%s\"\n", idn2_check_version(NULL));
+		++wlines;
+#	endif /* HAVE_LIBIDN2 && IDN2_VERSION */
+
+#	if defined(HAVE_LIBIDN) && defined(HAVE_STRINGPREP_H)
+		fprintf(fp, "\tIDN      = \"%s\"\n", stringprep_check_version("0.3.0"));
+		++wlines;
+#	endif /* HAVE_LIBIDN && HAVE_STRINGPREP_H */
+
+#	ifdef USE_ZLIB
+#		if defined(ZLIB_VERNUM) && ZLIB_VERNUM >= 0x1020
+		fprintf(fp, "\tZLIB     = \"%s\"\n", zlibVersion());
+#		else
+		fprintf(fp, "\tZLIB     = \"%s\"\n", ZLIB_VERSION);
+#endif /* ZLIB_VERNUM && ZLIB_VERNUM >= 0x1020 */
+		++wlines;
+#	endif /* USE_ZLIB */
+
+#	ifdef HAVE_LIBURIPARSER
+		fprintf(fp, "\tURIPARSER= \"%s\"\n", URI_VER_ANSI);
+		++wlines;
+#	else
+#		ifdef HAVE_LIBCURL
+		fprintf(fp, "\tCURL     = \"%s\"\n", LIBCURL_VERSION);
+		++wlines;
+#		endif /* HAVE_LIBCURL */
+#	endif /* HAVE_LIBURIPARSER */
+
+#	if defined(USE_CANLOCK) && defined(CL_API_MAJOR) && defined(CL_API_MINOR)
+		fprintf(fp, "\tCANLOCK  = \"%d.%d\"\n", CL_API_MAJOR, CL_API_MINOR);
+		++wlines;
+#	endif /* USE_CANLOCK && CL_API_MAJOR && CL_API_MINOR */
+	}
+#endif /* REPRODUCIBLE_BUILD */
+
+	fprintf(fp, "Characteristics:\n\t%s\n", tin_character);
 	wlines += 11;
+
+	if (verb >= 2) {
+		fprintf(fp, "Expected file versions:\n");
+		fprintf(fp, "\ttinrc      = %s\n", TINRC_VERSION);
+		fprintf(fp, "\tserverrc   = %s\n", SERVERCONFIG_VERSION);
+		fprintf(fp, "\tattributes = %s\n", ATTRIBUTES_VERSION);
+		fprintf(fp, "\tfilter     = %s\n", FILTER_VERSION);
+		fprintf(fp, "\tkeymap     = %s\n", KEYMAP_VERSION);
+		wlines += 6;
+	}
+
 	fflush(fp);
 	return wlines;
 }
@@ -4762,7 +4796,7 @@ draw_mark_selected(
 	for (j = art_mark_width - wcwidth(tinrc.art_marked_selected); j > 0; --j)
 		my_fputc(' ', stdout);
 	StartInverse();	/* ToggleInverse() doesn't work correct with ncurses4.x */
-	my_fputwc(tinrc.art_marked_selected, stdout);
+	my_fputwc((wint_t) tinrc.art_marked_selected, stdout);
 #else
 	StartInverse();	/* ToggleInverse() doesn't work correct with ncurses4.x */
 	my_fputc(tinrc.art_marked_selected, stdout);
@@ -4844,11 +4878,15 @@ show_connection_page(
 	void)
 {
 	FILE *fp;
+	char coninfo_file[PATH_LEN];
 
-	if (!(fp = my_tmpfile()))
-		return;
-
-	make_connection_page(fp);
+	/* check if we have cached the page already, if not create it */
+	joinpath(coninfo_file, sizeof(coninfo_file), serverdir, CONINFO_CACHE_FILE);
+	if ((fp = fopen(coninfo_file, "r")) == NULL) { /* ENOENT */
+		if ((fp = fopen(coninfo_file, "w+")) == NULL) /* TODO: error message */
+			return;
+		make_connection_page(fp);
+	}
 	info_pager(fp, _(txt_connection_info), FALSE); /* all other pagers do wrap */
 	fclose(fp);
 	info_pager(NULL, NULL, TRUE); /* free mem */
@@ -4859,6 +4897,8 @@ static void
 make_connection_page(
 	FILE *fp)
 {
+	t_bool add_slash;
+
 	if (!read_news_via_nntp)
 		fprintf(fp, "%s", _(txt_conninfo_local_spool));
 	else {
@@ -4868,8 +4908,7 @@ make_connection_page(
 #	if defined(NNTPS_ABLE)
 		else {
 			if (use_nntps) {
-				fprintf(fp, _(txt_conninfo_nntps), insecure_nntps ? _(txt_conninfo_untrusted) : _(txt_conninfo_trusted), can_post ? _(txt_conninfo_rw) : _(txt_conninfo_ro));
-
+				fprintf(fp, insecure_nntps ? _(txt_conninfo_untrusted) : _(txt_conninfo_trusted), can_post ? _(txt_conninfo_rw) : _(txt_conninfo_ro));
 #		ifdef HAVE_LIB_LIBTLS
 				fprintf(fp, txt_conninfo_libressl, TLS_API);
 #		else
@@ -4896,11 +4935,17 @@ make_connection_page(
 #endif /* NNTP_ABLE */
 	}
 
+	/*
+	 * TODO: do we want (#ifdef HAVE_REALPATH) to resolve symlinks
+	 *       (or show both like "ls -ld") in the display?
+	 */
 #ifndef NNTP_ONLY
 	if (!read_news_via_nntp && !read_saved_news) {
 		fprintf(fp, "%s", txt_conninfo_spool_config);
-		fprintf(fp, txt_conninfo_spooldir, spooldir);
-		fprintf(fp, txt_conninfo_novrootdir, novrootdir);
+		add_slash = (spooldir[strlen(spooldir) - 1] != '/');
+		fprintf(fp, txt_conninfo_spooldir, spooldir, add_slash ? "/" : "");
+		add_slash = (novrootdir[strlen(novrootdir) - 1] != '/');
+		fprintf(fp, txt_conninfo_novrootdir, novrootdir, add_slash ? "/" : "");
 		fprintf(fp, txt_conninfo_overview_file, novfilename); /* TODO: shows wrong name if using inn >= 2.3.0 nov-style */
 		fprintf(fp, txt_conninfo_overview_fmt, overviewfmt_file);
 		fprintf(fp, txt_conninfo_newsgroups_file, newsgroups_file);
@@ -4911,8 +4956,10 @@ make_connection_page(
 #endif /* !NNTP_ONLY */
 
 	fprintf(fp, "%s", _(txt_conninfo_conf_files));
+	/* TODO: hide if empty? */
 	fprintf(fp, "tin.defaults       : %s\n", global_defaults_file);
 
+	/* TODO: getext for "local"/"global" translation? */
 	fprintf(fp, "attributes (local) : %s\n", local_attributes_file);
 	if (*global_attributes_file)
 		fprintf(fp, "attributes (global): %s\n", global_attributes_file);
@@ -4921,6 +4968,8 @@ make_connection_page(
 	if (*global_config_file)
 		fprintf(fp, "tinrc (global)     : %s\n", global_config_file);
 
+	fprintf(fp, "serverrc           : %s\n", serverrc_file);
+
 	fprintf(fp, "filter             : %s\n", filter_file);
 
 	if (*keymap_file)
